# filename : listes.py
# Source : https://python-carnot.fr/nsi-terminale/listes/cours
# NSI Terminale - LPO Tani Malandi 


def cellule(tete, queue):
    """
    Construit une liste chaînée en rajoutant l'élément tête au
    *début* de la liste chaînée queue. La liste queue n'est pas
    modifiée par cette opération.

    Renvoie une cellule variable.
    """

    return [tete, queue]


def liste_vide():
    """
    Renvoie une liste chaînée vide.
    """

    return None


def change_tete(cellule, nouvelle_valeur):
    """
    Modifie la valeur de tête de la liste
    """

    cellule[0] = nouvelle_valeur


def change_queue(cellule, nouvelle_cellule):
    """
    Modifie la valeur de la queue de la liste: la cellule
    pointera sur une nouvelle cellule.
    """

    cellule[1] = nouvelle_cellule


def tete(liste):
    """
    Renvoie le premier élément de la liste chaînée passée en
    paramètre.
    """

    return liste[0]


def queue(liste):
    """
    Renvoie la liste chaînée liste privée de son premier élément
    (la liste passée en paramètre n'est cependant pas modifiée
    par cette opération).

    Déclenche une erreur si appelé sur une liste vide.
    """

    return liste[1]




def est_vide(liste):
    """
    Teste si une liste chaînée est vide ou non.
    """

    return liste is None


def longueur(liste):
    """
    Retourne la longueur de la liste chaînée passée en paramètre.
    """

    if liste is None:
        return 0
    else:
        return 1 + longueur(queue(liste))


def concatener(l1, l2):
    """
    Renvoie une nouvelle liste chaînée qui sera la concaténation
    de l1 et de l2.

    Les listes l1 et l2 ne sont pas modifiées par cette appel.
    """

    if est_vide(l1):
        return l2
    else:
        return cellule(tete(l1), concatener(queue(l1), l2))
